﻿using System.Text;
using System;
using System.Collections;
using maddox.game;
using maddox.game.world;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;



public class Mission : AMission
{
    // public override void OnActorDestroyed(int missionNumber, string shortName, AiActor actor)
    // {
    // GamePlay.gpHUDLogCenter( " toto ");
    // GamePlay.gpPostMissionLoad("missions/Panzer2.mis");
    // }
    public long Tick_Mission_Time { get; set; }// Sets the Mission Clock for Time Remaining in Mission.
    List<AiGroundActor> enemyGroundActorsInGame = new List<AiGroundActor>();
    // const int EnemyArmy = 1; // reds are enemy change to 2 for blues
    const int MinNumberEnemyPlanesAlive = 1; // number of enemy planes left before creating new airgroup 
    // int number_of_tanks_destroyed = 0;
    // int number_of_army1_tanks_destroyed = 0;
    // int number_of_army2_tanks_destroyed = 0;
    int number_of_halftrak_destroyed = 0;
    int number_of_panzer_destroyed = 0;
    int number_of_automitrailleuse_destroyed = 0;
    int number_of_tank_destroyed = 0;
    bool flag_groupe_detruit = false;
	bool il_y_a_un_vainqueur = false;
	int nombre_de_chars_dans_groupe = 6;
	int nombre_de_voiture_blindée_dans_groupe = 4;
	
	int nombre_de_chars_a_détruire = 24; // mulitple de 6
	int nombre_de_voiture_blindée_a_détruire = 16; // mulitple de 4
	
	int nombre_de_Halftrack_créés = 8; // nombre de Halftrack au début de la mission
	int nombre_d_Automitrailleuse_brit_créés = 8; // nombre de Automitrailleuse_brit au début de la mission
	int nombre_de_Panzer_créés = 12; // nombre de Panzer au début de la mission
	int nombre_de_Tank_brit_créés = 12; // nombre de Tank_brit au début de la mission	
	
	int duration = 216000; // (en tick) 30 ticks = 1 sec
	// int duration = 1800; // (en tick) 30 ticks = 1 sec	

    string Objective_Total_Red = "";
    string Objective_Total_Blue = "";	

    // System.IO.FileInfo fi = new System.IO.FileInfo("C:\\Users\\Mic\\Desktop\\Mikmak_script.txt");
    System.IO.StreamWriter sw;

    private Queue<string> ActionQueue_Halftrack = new Queue<string>(new string[] { "apparition_halftrack" });
    private Queue<string> ActionQueue_Panzer = new Queue<string>(new string[] { "apparition_panzer" });
	private Queue<string> ActionQueue_Automitrailleuse_brit = new Queue<string>(new string[] { "apparition_Automitrailleuse_brit" });
	private Queue<string> ActionQueue_Tank_brit = new Queue<string>(new string[] { "apparition_Tank_brit" });



	public void _DespawnEmptyPlane(AiActor actor)
	{
		if (actor == null)
		{
			return;
		}
		Player[] Players = GamePlay.gpRemotePlayers();
		bool PlaneIsEmpty = true;
		foreach (Player i in Players)
		{	
			if ((i.Place() as AiAircraft) == (actor as AiAircraft))
			{ 
				PlaneIsEmpty = false;
				break;
			}
		}
		if (PlaneIsEmpty)
		{
			(actor as AiAircraft).Destroy();
		}
	}

	public override void OnPlaceLeave(Player player, AiActor actor, int placeIndex)
	{
		base.OnPlaceLeave(player, actor, placeIndex);
		Timeout(40, () =>
		{
			_DespawnEmptyPlane(actor);
		});
	}
	
    public override void OnBattleStarted()
    {
        base.OnBattleStarted();

        MissionNumberListener = -1;
    }


    public override void OnActorCreated(int missionNumber, string shortName, AiActor actor)
    {
        base.OnActorCreated(missionNumber, shortName, actor);

        if (actor is AiGroundActor)
            enemyGroundActorsInGame.Add(actor as AiGroundActor);
        // GamePlay.gpHUDLogCenter(" create " + enemyGroundActorsInGame.Count);
    }


    //public override void OnAircraftKilled(int missionNumber, string shortName, AiAircraft aircraft)
    //{
    //    base.OnAircraftKilled(missionNumber, shortName, aircraft);

    //    enemyAircraftsInGame.RemoveAll(item => item == aircraft);

    //    if (enemyAircraftsInGame.Count == MinNumberEnemyPlanesAlive)
    //    {
    //        string actionName = ActionQueue.Dequeue();
    //        ActionQueue.Enqueue(actionName);

    //        AiAction action = GamePlay.gpGetAction(actionName);
    //        if (action != null) action.Do();
    //    }
    //    GamePlay.gpHUDLogCenter(" OnAircraftKilled ");
    //}


    public override void OnActorDead(int missionNumber, string shortName, AiActor actor, List<DamagerScore> damages)
    {
        base.OnActorDead(missionNumber, shortName, actor, damages);

        AiGroundActor groundActor = actor as AiGroundActor;
        if (actor is AiGroundGroup)
        {
            flag_groupe_detruit = true;
            // GamePlay.gpLogServer(null, " flag_groupe_detruit = true ", new object[] { });	
        }
		
        if (actor.Army() == 1)
        {
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Breen_Carrier_Mk_I") == 0) // automitrailleuse britanique
            {
                number_of_automitrailleuse_destroyed = number_of_automitrailleuse_destroyed + 1;
				GamePlay.gpLogServer(null, number_of_automitrailleuse_destroyed + "/" + nombre_de_voiture_blindée_a_détruire + " automitrailleuses britaniques détruites ", new object[] { });
                // GamePlay.gpHUDLogCenter(number_of_automitrailleuse_destroyed + " automitrailleuses britaniques détruites ");
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Cruiser_Mk_IVA") == 0) // tank britanique
            {
                number_of_tank_destroyed = number_of_tank_destroyed + 1;
				GamePlay.gpLogServer(null, number_of_tank_destroyed + "/" + nombre_de_chars_a_détruire + " tanks britaniques détruits ", new object[] { });
                // GamePlay.gpHUDLogCenter(number_of_tank_destroyed + " tanks britaniques détruits ");
            }
            //number_of_army1_tanks_destroyed = number_of_army1_tanks_destroyed + 1;
            // GamePlay.gpHUDLogCenter(number_of_army1_tanks_destroyed + " unités britaniques détruites " + groundActor.InternalTypeName().ToString());
        }
        if (actor.Army() == 2)
        {
            //if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.SdKfz_10_4") == 0) // halftrak allemand
			if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Krupp_L2H43_Protze_Kfz69_pak35") == 0) // halftrak allemand
            {
                number_of_halftrak_destroyed = number_of_halftrak_destroyed + 1;
				GamePlay.gpLogServer(null, number_of_halftrak_destroyed + "/" + nombre_de_voiture_blindée_a_détruire + " halftraks allemands détruits ", new object[] { });
                // GamePlay.gpHUDLogCenter(number_of_halftrak_destroyed + " halftraks allemands détruits ");
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Pz_IIC") == 0) // panzer allemand
            {
                number_of_panzer_destroyed = number_of_panzer_destroyed + 1;
				GamePlay.gpLogServer(null, number_of_panzer_destroyed + "/" + nombre_de_chars_a_détruire + " panzer allemands détruits ", new object[] { });
                // GamePlay.gpHUDLogCenter(number_of_panzer_destroyed + " panzer allemands détruits ");
            }
            //number_of_army2_tanks_destroyed = number_of_army2_tanks_destroyed + 1;
            // GamePlay.gpHUDLogCenter(number_of_army2_tanks_destroyed + " unités allemandes détruites " + groundActor.InternalTypeName().ToString());
        }
        //number_of_tanks_destroyed = number_of_tanks_destroyed + 1;
        //GamePlay.gpHUDLogCenter(number_of_tanks_destroyed + "tanks détruits armée " + actor.Army());		

        if (flag_groupe_detruit)
        {
            //if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.SdKfz_10_4") == 0) // halftrak allemand
			if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Krupp_L2H43_Protze_Kfz69_pak35") == 0 && nombre_de_Halftrack_créés < nombre_de_voiture_blindée_a_détruire) // halftrak allemand
            {
				nombre_de_Halftrack_créés = nombre_de_Halftrack_créés + nombre_de_voiture_blindée_dans_groupe;
                GamePlay.gpLogServer(null, " Des renforts de halftrack allemands ont été signalés sur la route à l'est du pont E3.7 ", new object[] { });
                string actionName = ActionQueue_Halftrack.Dequeue();
                ActionQueue_Halftrack.Enqueue(actionName);
                AiAction action = GamePlay.gpGetAction(actionName);
                if (action != null) action.Do();
				flag_groupe_detruit = false;
				// GamePlay.gpLogServer(null, " flag_groupe_detruit = false ", new object[] { });
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Pz_IIC") == 0 &&  nombre_de_Panzer_créés < nombre_de_chars_a_détruire) // panzer allemand
            {
				nombre_de_Panzer_créés = nombre_de_Panzer_créés + nombre_de_chars_dans_groupe;			
				GamePlay.gpLogServer(null, " Des renforts de panzer allemands ont été signalés sur la route à l'est du pont E3.7  ", new object[] { });
				string actionName = ActionQueue_Panzer.Dequeue();
				ActionQueue_Panzer.Enqueue(actionName);
				AiAction action = GamePlay.gpGetAction(actionName);
				if (action != null) action.Do();
				flag_groupe_detruit = false;
				// GamePlay.gpLogServer(null, " flag_groupe_detruit = false ", new object[] { });
            }	
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Breen_Carrier_Mk_I") == 0 && nombre_d_Automitrailleuse_brit_créés < nombre_de_voiture_blindée_a_détruire) // automitrailleuse britanique
            {
				nombre_d_Automitrailleuse_brit_créés = nombre_d_Automitrailleuse_brit_créés + nombre_de_voiture_blindée_dans_groupe;				
                GamePlay.gpLogServer(null, " Des renforts d'automitrailleuse britaniques ont été signalés sur la route à l'ouest du pont E3.7  ", new object[] { });
                string actionName = ActionQueue_Automitrailleuse_brit.Dequeue();
                ActionQueue_Automitrailleuse_brit.Enqueue(actionName);
                AiAction action = GamePlay.gpGetAction(actionName);
                if (action != null) action.Do();
				flag_groupe_detruit = false;
				// GamePlay.gpLogServer(null, " flag_groupe_detruit = false ", new object[] { });
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Cruiser_Mk_IVA") == 0 &&  nombre_de_Tank_brit_créés < nombre_de_chars_a_détruire) // tank britanique
            {
				nombre_de_Tank_brit_créés = nombre_de_Tank_brit_créés + nombre_de_chars_dans_groupe;			
				GamePlay.gpLogServer(null, " Des renforts de chars britaniques ont été signalés sur la route à l'ouest du pont E3.7  ", new object[] { });
				string actionName = ActionQueue_Tank_brit.Dequeue();
				ActionQueue_Tank_brit.Enqueue(actionName);
				AiAction action = GamePlay.gpGetAction(actionName);
				if (action != null) action.Do();
				flag_groupe_detruit = false;
				// GamePlay.gpLogServer(null, " flag_groupe_detruit = false ", new object[] { });
            }				
        }

		if (number_of_automitrailleuse_destroyed >= nombre_de_voiture_blindée_a_détruire && number_of_tank_destroyed >= nombre_de_chars_a_détruire && il_y_a_un_vainqueur == false)
		{
			il_y_a_un_vainqueur = true;	
            GamePlay.gpLogServer(null, "victoire des bleus / blue victory ", new object[] { });
            GamePlay.gpHUDLogCenter("victoire des bleus / blue victory ");			
            Timeout(30, () =>
            {
                GamePlay.gpLogServer(null, "Le serveur redémarre dans 1 min / Server Restarting in 1 minute", new object[] { });
                GamePlay.gpHUDLogCenter("Le serveur redémarre dans 1 min / Server Restarting in 1 minute");
            });
			Timeout(60, () =>
            {
                GamePlay.gpLogServer(null, "Mission stopped. wait 2 minutes to recconect!!!", new object[] { });
                GamePlay.gpHUDLogCenter("Mission stopped. wait 2 minutes to recconect!!!");
            });
			Timeout(90, () =>
            {
				GamePlay.gpBattleStop();
            });				
			Timeout(100, () =>
			{
				Process.GetCurrentProcess().Kill();
			});
		}

        if (number_of_halftrak_destroyed >= nombre_de_voiture_blindée_a_détruire && number_of_panzer_destroyed >= nombre_de_chars_a_détruire && il_y_a_un_vainqueur == false)
        {
			il_y_a_un_vainqueur = true;		
            GamePlay.gpLogServer(null, "victoire des rouges / red victory ", new object[] { });
            GamePlay.gpHUDLogCenter("victoire des rouges / red victory ");			
            Timeout(30, () =>
            {
                GamePlay.gpLogServer(null, "Le serveur redémarre dans 1 min / Server Restarting in 1 minute", new object[] { });
                GamePlay.gpHUDLogCenter("Le serveur redémarre dans 1 min / Server Restarting in 1 minute");
            });
			Timeout(60, () =>
            {
                GamePlay.gpLogServer(null, "Mission stopped. wait 2 minutes to recconect!!!", new object[] { });
                GamePlay.gpHUDLogCenter("Mission stopped. wait 2 minutes to recconect!!!");
            });
			Timeout(90, () =>
            {
				GamePlay.gpBattleStop();
            });			
			Timeout(100, () =>
			{
				Process.GetCurrentProcess().Kill();
			});
        }		
    }
    public override void OnActorTaskCompleted(int missionNumber, string shortName, AiActor actor)
    {
/*        AiGroundActor groundActor = actor as AiGroundActor;	
        if (actor.Army() == 1)
        {
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Breen_Carrier_Mk_I") == 0) // automitrailleuse britanique
            {
				GamePlay.gpLogServer(null, " Des automitrailleuses britaniques se trouvent à proximité du pont E3.7 à l'ouest ", new object[] { });
				// GamePlay.gpHUDLogCenter(" tanks britanique sur zone ");
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Cruiser_Mk_IVA") == 0) // tank britanique
            {
				GamePlay.gpLogServer(null, " Des tanks britaniques se trouvent à proximité du pont E3.7 à l'ouest ", new object[] { });
				// GamePlay.gpHUDLogCenter(" tanks britanique sur zone ");
            }
            //number_of_army1_tanks_destroyed = number_of_army1_tanks_destroyed + 1;
            //GamePlay.gpHUDLogCenter(number_of_army1_tanks_destroyed + " unités britaniques détruites " + groundActor.InternalTypeName().ToString());
        }
        if (actor.Army() == 2)
        {
            //if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.SdKfz_10_4") == 0) // halftrak allemand
			if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Krupp_L2H43_Protze_Kfz69_pak35") == 0) // halftrak allemand
            {
				GamePlay.gpLogServer(null, " Des halftraks allemands se trouvent à proximité du pont E3.7 à l'est ", new object[] { });
				// GamePlay.gpHUDLogCenter(" tanks allemands sur zone ");
            }
            if (string.CompareOrdinal(groundActor.InternalTypeName().ToString(), "bob:Tank.Pz_IIC") == 0) // panzer allemand
            {
				GamePlay.gpLogServer(null, " Des panzers allemands se trouvent à proximité du pont E3.7 à l'est ", new object[] { });
				// GamePlay.gpHUDLogCenter(" tanks allemands sur zone ");
            }
            //number_of_army2_tanks_destroyed = number_of_army2_tanks_destroyed + 1;
            //GamePlay.gpHUDLogCenter(number_of_army2_tanks_destroyed + " unités allemandes détruites " + groundActor.InternalTypeName().ToString());
        }
        //number_of_tanks_destroyed = number_of_tanks_destroyed + 1;
        //GamePlay.gpHUDLogCenter(number_of_tanks_destroyed + "tanks détruits armée " + actor.Army());	
*/		
        if (actor.Army() == 1)
		{
			GamePlay.gpLogServer(null, " Des troupes britaniques se trouvent à proximité du pont E3.7 à l'ouest ", new object[] { });
			// GamePlay.gpHUDLogCenter(" tanks britanique sur zone ");
		}
        if (actor.Army() == 2)
        {
			GamePlay.gpLogServer(null, " Des troupes allemandes se trouvent à proximité du pont E3.7 à l'est ", new object[] { });
            // GamePlay.gpHUDLogCenter(" tanks allemands sur zone ");
        }	
    }
    // public override void OnPersonParachuteLanded(AiPerson person)
    // {
        // base.OnPersonParachuteLanded(person);
        // sw = fi.AppendText();                                       // write to file
        // sw.WriteLine(" land with parachute");
        // sw.Close();

    // }
    // public override void OnActorDamaged(int missionNumber, string shortName, AiActor actor, AiDamageInitiator initiator, part.NamedDamageTypes damageType)
    // {
        // base.OnActorDamaged(missionNumber, shortName, actor, initiator, damageType);
        // sw = fi.AppendText();                                       // write to file
        // sw.WriteLine(actor.Name() + "damaged :" + damageType);
        // sw.Close();
    // }
    // public override void OnAircraftDamaged(int missionNumber, string shortName, AiAircraft aircraft, AiDamageInitiator initiator, part.NamedDamageTypes damageType)
    // {
        // base.OnAircraftDamaged(missionNumber, shortName, aircraft, initiator, damageType);
        // sw = fi.AppendText();                                       // write to file
        // sw.WriteLine(aircraft.Player(0).Name() + "damaged :");
        // sw.Close();
    // }
    // public override void OnAircraftCrashLanded(int missionNumber, string shortName, AiAircraft aircraft)
    // {
        // base.OnAircraftCrashLanded(missionNumber, shortName, aircraft);
        // sw = fi.AppendText();                                       // write to file
        // sw.WriteLine(aircraft.Player(0).Name() + " crash landed its plane");
        // sw.Close();

    // }
	
	public string GetRedObjectivesString()
	{
		string StringToReturn="";
		StringToReturn="Completed Red Objectives:\n";
		StringToReturn=StringToReturn + Objective_Total_Red;
		return StringToReturn;
	}
	
	public string GetBlueObjectivesString()
	{
		string StringToReturn="";
		StringToReturn="Completed Blue Objectives:\n";
		StringToReturn=StringToReturn + Objective_Total_Blue;
		return StringToReturn;
	}
	
	public string GetTimeLeftString()
	{
		string StringToReturn="";
		StringToReturn="Time Remaining In Mission:\n";
		
        TimeSpan Convert_Ticks = TimeSpan.FromMinutes((duration - Time.tickCounter()) / 2000);
        string Time_Remaining = string.Format("{0:D2}:{1:D2}:{2:D2}", Convert_Ticks.Hours, Convert_Ticks.Minutes, Convert_Ticks.Seconds);
		
		StringToReturn=StringToReturn + Time_Remaining;
		return StringToReturn;
	}	
	
    public override void OnTickGame()
    {
        Tick_Mission_Time = duration - Time.tickCounter();
        var Mission_Time = Tick_Mission_Time / 2000;
        TimeSpan Convert_Ticks = TimeSpan.FromMinutes(Mission_Time);
        string Time_Remaining = string.Format("{0:D2}:{1:D2}:{2:D2}", Convert_Ticks.Hours, Convert_Ticks.Minutes, Convert_Ticks.Seconds);

        if (Time.tickCounter() % 30000 == 1000)
        {
            GamePlay.gpLogServer(null, "Completed Blue Objectives:", new object[] { });
			GamePlay.gpLogServer(null, number_of_automitrailleuse_destroyed + "/" + nombre_de_voiture_blindée_a_détruire + " automitrailleuses britaniques détruites ", new object[] { });
			GamePlay.gpLogServer(null, number_of_tank_destroyed + "/" + nombre_de_chars_a_détruire + " tanks britaniques détruits ", new object[] { });
            Timeout(5, () =>
			{
            GamePlay.gpLogServer(null, "Completed Red Objectives:", new object[] { });
			GamePlay.gpLogServer(null, number_of_halftrak_destroyed + "/" + nombre_de_voiture_blindée_a_détruire + " halftraks allemands détruits ", new object[] { });
			GamePlay.gpLogServer(null, number_of_panzer_destroyed + "/" + nombre_de_chars_a_détruire + " panzer allemands détruits ", new object[] { });
			});
            Timeout(10, () =>
            GamePlay.gpLogServer(null, "Temps restant / Time Remaining : " + Time_Remaining, new object[] { }));
        }

        if (Time.tickCounter() == duration)// Out of time.
        {
	    Timeout(10, () =>
	    {
            	GamePlay.gpLogServer(null, "Pas de victoire / no victory", new object[] { });
            	GamePlay.gpHUDLogCenter("Pas de victoire / no victory");
	    });
            Timeout(30, () =>
	    {
            	GamePlay.gpLogServer(null, "Le serveur redémarre dans 1 min / Server Restarting in 1 minute", new object[] { });
            	GamePlay.gpHUDLogCenter("Le serveur redémarre dans 1 min / Server Restarting in 1 minute");
	    });
            Timeout(90, () =>
	    {
            	GamePlay.gpLogServer(null, "Mission stopped. wait 2 minutes to reconnect!!!", new object[] { });
            	GamePlay.gpHUDLogCenter("Mission stopped. wait 2 minutes to reconnect!!!");
	    });
            Timeout(100, () =>
	    {
            Process.GetCurrentProcess().Kill();
	    });
        }	
        // base.OnTickGame();
        // if (Time.tickCounter() % 30 == 1)               // tick ~ 1/30 second, 30 ticks ~ 1 second
        // {
            // AiAircraft curPlane = GamePlay.gpPlayer().Place() as AiAircraft; // get player aircraft
            // if (curPlane != null)
            // {
                // double i_IAS = curPlane.getParameter(part.ParameterTypes.I_VelocityIAS, -1); // get TAS and alt.
                // double i_IAlt = curPlane.getParameter(part.ParameterTypes.I_Altitude, -1);
                // System.Console.WriteLine("IAS :{0}", i_IAS);                   // write to console
                // System.Console.WriteLine("Alt :{0}", i_IAlt);

                // sw = fi.AppendText();                                       // write to file
                // sw.WriteLine("Time:{0}; IAS :{0}; Alt :{0}", Time.currentReal(), i_IAS, i_IAlt);
                // sw.Close();
            // }
        // }
    }
    // public override void OnPlaceEnter(Player player, AiActor actor, int placeIndex)
    // {
        // base.OnPlaceEnter(player, actor, placeIndex);
        // sw = fi.AppendText();                                       // write to file
        // sw.WriteLine(player.Name() + " take place : {0} as " + actor.Name(), placeIndex);
        // sw.Close();
    // }

    // public override void OnPlaceLeave(Player player, AiActor actor, int placeIndex)
    // {
        // base.OnPlaceLeave(player, actor, placeIndex);

        // if (IsActorDestroyable(actor))
            // if (actor is AiCart)
                // (actor as AiCart).Destroy();
    // }


    private bool IsActorDestroyable(AiActor actor)
    {
        bool actorDestroyable = true;

        //Check if actor is empty (no Player)
        if (actor is AiGroundActor)
        {
            if ((actor as AiGroundActor).ExistCabin(0))
                for (int i = 0; i < (actor as AiGroundActor).Places(); i++)
                {
                    if ((actor as AiGroundActor).Player(i) != null)
                    {
                        actorDestroyable = false;
                        break;
                    }
                }
        }
        else if (actor is AiGroundActor)
        {
            if ((actor as AiGroundActor).ExistCabin(0))
                for (int i = 0; i < (actor as AiGroundActor).Places(); i++)
                {
                    if ((actor as AiGroundActor).Player(i) != null)
                    {
                        actorDestroyable = false;
                        break;
                    }
                }
        }

        return actorDestroyable;
    }
	
}
